//////////////////////////////////////////////////////////////////////////
// spieleprogrammierer.de-Programmier-Contest #11                       //
// ******************************************************************** //
// Titel: ...... "Rechnen einmal anders"                                //
// Typ: ........ Krze des Codes                                        //
// Deadline: ... 18.01.2009                                             //
// Abgabe: ..... contest@spieleprogrammierer.de                         //
// ******************************************************************** //
//                                                                      //
// Aufgabenstellung und Regeln siehe:                                   //
// http://www.spieleprogrammierer.de/phpBB2/viewtopic.php?t=10773       //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include <iostream>
#include "utils.h"

//////////////////////////////////////////////////////////////////////////

// die Rechenoperationen
enum Operation
{
    ADD,
    SUBTRACT,
    MULTIPLY,
    DIVIDE
};

//////////////////////////////////////////////////////////////////////////

// "my_nickname" bitte durch deinen Nickname ersetzen, z.B. "hans_wurst".
// Zum Einreichen der Lsung einfach den kompletten Namespace schicken!
namespace my_nickname
{
    // >>> DEINE FUNKTION - BITTE IMPLEMENTIEREN! <<<
    int16_t calculate(Operation op,
                      int16_t x,
                      int16_t y)
    {
        // BEGIN COUNT

        // Hier werden die Token gezhlt!

        return 0;

		// END COUNT
    }
}

//////////////////////////////////////////////////////////////////////////

int main()
{
    const uint32_t NUM_TESTS = 10000;
    const bool STOP_AT_FIRST_ERROR = true;

    MTRand rand;
    uint32_t num_errors = 0;
    for(uint32_t i = 0; i < NUM_TESTS; ++i)
    {
        // zufllige Operation und Operanden auswhlen
        const Operation op = static_cast<Operation>(rand() % 4);
        const int16_t x = static_cast<int16_t>(rand());
        const int16_t y = static_cast<int16_t>(rand());

        // korrektes Ergebnis berechnen
        int16_t correct_result = 0;
        switch(op)
        {
            case ADD:
                correct_result = x + y;
                break;
            case SUBTRACT:
                correct_result = x - y;
                break;
            case MULTIPLY:
                correct_result = x * y;
                break;
            case DIVIDE:
                // Keine Division durch Null zulassen!
                if(!y) { --i; continue; }
                correct_result = x / y;
                break;
        }

        // Funktion rechnen lassen und Ergebnis vergleichen
        const int16_t result = my_nickname::calculate(op, x, y);
        if(result != correct_result)
        {
            // Fehler!
            std::cout << "Falsch: " << x << ' ' << "+-*/"[op] << ' ' << y << " = " << result << " (richtig: " << correct_result << ')' << std::endl;
            ++num_errors;
            if(STOP_AT_FIRST_ERROR) break;
        }
    }

    if(!STOP_AT_FIRST_ERROR) std::cout << num_errors << " Fehler insgesamt" << std::endl;
}
